// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTMM_BUS_H
#define _GSTMM_BUS_H


#include <glibmm.h>

#include <gstreamermm/object.h>
#include <gstreamermm/clock.h>
#include <gstreamermm/enums.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstBus GstBus;
typedef struct _GstBusClass GstBusClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class Bus_Class; } // namespace Gst
namespace Gst
{

class Message;


class Bus : public Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Bus CppObjectType;
  typedef Bus_Class CppClassType;
  typedef GstBus BaseObjectType;
  typedef GstBusClass BaseClassType;

private:  friend class Bus_Class;
  static CppClassType bus_class_;

private:
  // noncopyable
  Bus(const Bus&);
  Bus& operator=(const Bus&);

protected:
  explicit Bus(const Glib::ConstructParams& construct_params);
  explicit Bus(GstBus* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Bus();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstBus*       gobj()       { return reinterpret_cast<GstBus*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstBus* gobj() const { return reinterpret_cast<GstBus*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstBus* gobj_copy();

private:


protected:
  Bus();

public:
  static Glib::RefPtr<Bus> create();
  
  bool post(const Glib::RefPtr<Message>& message);
  
  bool have_pending() const;

  
  Glib::RefPtr<Message> peek();
  
  Glib::RefPtr<const Message> peek() const;

  
  Glib::RefPtr<Message> pop();
  
  Glib::RefPtr<Message> timed_pop(ClockTime timeout);

  
  void set_flushing(bool flushing = true);

  /** For example,
   * bool on_bus_watch(const Glib::RefPtr<Bus>& bus, const Glib::RefPtr<Message>& message);
   */
  typedef sigc::slot<bool, const Glib::RefPtr<Bus>&, const Glib::RefPtr<Message>& > SlotWatch;
  guint add_watch(const SlotWatch& slot, int priority = G_PRIORITY_DEFAULT);
  bool remove_watch(guint watch_id);
  

  void disable_sync_message_emission();
  
  void enable_sync_message_emission();

  
  void add_signal_watch(int priority = G_PRIORITY_DEFAULT);
  
  void remove_signal_watch();
  

  /**
   * @par Prototype:
   * <tt>void on_my_%message(const Glib::RefPtr<Message>& message)</tt>
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<Message>& > signal_message();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%sync_message(const Glib::RefPtr<Message>& message)</tt>
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<Message>& > signal_sync_message();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_message(const Glib::RefPtr<Message>& message);
  virtual void on_sync_message(const Glib::RefPtr<Message>& message);
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} //namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::Bus
   */
  Glib::RefPtr<Gst::Bus> wrap(GstBus* object, bool take_copy = false);
}


#endif /* _GSTMM_BUS_H */

