// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTMM_ELEMENT_H
#define _GSTMM_ELEMENT_H


#include <glibmm.h>

#include <gstreamermm/object.h>
#include <gstreamermm/clock.h>
#include <gstreamermm/enums.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstElement GstElement;
typedef struct _GstElementClass GstElementClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class Element_Class; } // namespace Gst
namespace Gst
{

class Bus;
class Caps;
class Clock;
class Event;
class Message;
class Pad;
class PadTemplate;
class Query;


class Element : public Object 
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Element CppObjectType;
  typedef Element_Class CppClassType;
  typedef GstElement BaseObjectType;
  typedef GstElementClass BaseClassType;

private:  friend class Element_Class;
  static CppClassType element_class_;

private:
  // noncopyable
  Element(const Element&);
  Element& operator=(const Element&);

protected:
  explicit Element(const Glib::ConstructParams& construct_params);
  explicit Element(GstElement* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Element();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstElement*       gobj()       { return reinterpret_cast<GstElement*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstElement* gobj() const { return reinterpret_cast<GstElement*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstElement* gobj_copy();

private:


protected:
  //TODO: What C function does this correspond to?
  Element();

public:
  static Glib::RefPtr<Element> create(const Glib::ustring& factoryname, const Glib::ustring& name);
  Glib::RefPtr<Element> link(const Glib::RefPtr<Element>& other_element);
  
  bool add_pad(const Glib::RefPtr<Pad>& pad);
  
  Glib::RefPtr<Pad> get_pad(const Glib::ustring& name);
  
  void create_all_pads();

  //TODO: Why does this throw an exception? murrayc
  Glib::RefPtr<Pad> get_compatible_pad(const Glib::RefPtr<Pad>& pad, const Glib::RefPtr<Caps>& caps);
  Glib::RefPtr<PadTemplate> get_compatible_pad_template(const Glib::RefPtr<PadTemplate>& padtemplate);

  
  Glib::RefPtr<Pad> get_request_pad(const Glib::ustring& name);
  
  Glib::RefPtr<Pad> get_static_pad(const Glib::ustring& name);
  
  void no_more_pads();
  
  void release_request_pad(const Glib::RefPtr<Pad>& pad);
  
  bool remove_pad(const Glib::RefPtr<Pad>& pad);
 
  
  void unlink(const Glib::RefPtr<Element>& other_element);

  
  bool link_pads(const Glib::ustring& padname, const Glib::RefPtr<Element>& other_element, const Glib::ustring& others_padname);

  
  void unlink_pads(const Glib::ustring& padname, const Glib::RefPtr<Element>& other_element, const Glib::ustring& other_padname);

  //TODO: Use ustring?:
  
  bool link_pads_filtered(const char* padname, const Glib::RefPtr<Element>& other_element, const char* others_padname, const Glib::RefPtr<Caps>& filter);

  
  bool link_filtered(const Glib::RefPtr<Element>& other_element, const Glib::RefPtr<Caps>& filter);
  
  void set_base_time(ClockTime time);
  
  ClockTime get_base_time() const;
  
  void set_bus(const Glib::RefPtr<Bus>& bus);
  
  Glib::RefPtr<Bus> get_bus();
  
  Glib::RefPtr<const Bus> get_bus() const;

  
  bool is_indexable() const;
  
  bool requires_clock() const;
  
  bool set_clock(const Glib::RefPtr<Clock>& clock);
  
  Glib::RefPtr<Clock> get_clock();
  
  Glib::RefPtr<const Clock> get_clock() const;
  
  bool provides_clock() const;
  
  Glib::RefPtr<Clock> provide_clock();
  
  Glib::RefPtr<const Clock> provide_clock() const;
  
  StateChangeReturn set_state(State state);
  
  StateChangeReturn get_state(State& state, State& pending, ClockTime timeout) const;
  
  bool set_locked_state(gboolean locked_state);
  
  bool is_locked_state() const;
  
  void abort_state();
  
  StateChangeReturn continue_state(StateChangeReturn prestate_value);
  
  void lost_state();
  
  bool sync_state_with_parent();
  
  StateChangeReturn change_state(StateChange transition);

  
  bool post_message(const Glib::RefPtr<Message>& message);

  
  bool query(const Glib::RefPtr<Query>& query);
  
  bool query_convert(Format src_format, gint64 src_value, Format& dst_format, gint64& dst_value) const;
  
  bool query_position(Format& format, gint64& position) const;
  
  bool query_duration(Format& format, gint64& duration) const;

  bool query_position(Format& format) const;
  bool query_duration(Format& format) const;

  
  bool seek(Format format, SeekFlags flags, gint64 position);
  
  bool seek(double rate, Format format, SeekFlags flags, SeekType current_type, gint64 current_position, SeekType stop_type, gint64 stop_position);

  bool send_event(const Glib::RefPtr<Event>& event);

  
  /**
   * @par Prototype:
   * <tt>void on_my_%no_more_pads()</tt>
   */

  Glib::SignalProxy0< void > signal_no_more_pads();


  /**
   * @par Prototype:
   * <tt>void on_my_%pad_added(const Glib::RefPtr<Pad>& new_pad)</tt>
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<Pad>& > signal_pad_added();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%pad_removed(const Glib::RefPtr<Pad>& old_pad)</tt>
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<Pad>& > signal_pad_removed();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_no_more_pads();
  virtual void on_pad_added(const Glib::RefPtr<Pad>& new_pad);
  virtual void on_pad_removed(const Glib::RefPtr<Pad>& old_pad);
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::Element
   */
  Glib::RefPtr<Gst::Element> wrap(GstElement* object, bool take_copy = false);
}


#endif /* _GSTMM_ELEMENT_H */

