// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTMM_PAD_H
#define _GSTMM_PAD_H


#include <glibmm.h>

#include <gstreamermm/object.h>
#include <gstreamermm/enums.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstPad GstPad;
typedef struct _GstPadClass GstPadClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class Pad_Class; } // namespace Gst
namespace Gst
{

class Caps;
class Element;
class PadTemplate;


class Pad : public Object 
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Pad CppObjectType;
  typedef Pad_Class CppClassType;
  typedef GstPad BaseObjectType;
  typedef GstPadClass BaseClassType;

private:  friend class Pad_Class;
  static CppClassType pad_class_;

private:
  // noncopyable
  Pad(const Pad&);
  Pad& operator=(const Pad&);

protected:
  explicit Pad(const Glib::ConstructParams& construct_params);
  explicit Pad(GstPad* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Pad();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstPad*       gobj()       { return reinterpret_cast<GstPad*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstPad* gobj() const { return reinterpret_cast<GstPad*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstPad* gobj_copy();

private:


protected:
  Pad();

public:
  // The C API has gst_pad_new, we just use the very common ::create() here
  static Glib::RefPtr<Pad> create(const Glib::ustring& name, PadDirection direction);

  
  PadDirection get_direction() const;
  
  Glib::RefPtr<Element> get_parent_element();
  
  Glib::RefPtr<const Element> get_parent_element() const;
  
  PadLinkReturn link(const Glib::RefPtr<Pad>& sink_pad);
  
  bool unlink(const Glib::RefPtr<Pad>& sink_pad);
  
  bool is_linked() const;
  
  bool can_link(const Glib::RefPtr<Pad>& other_pad);
  
  Glib::RefPtr<Caps> get_caps();
  
  Glib::RefPtr<const Caps> get_caps() const;
  
  Glib::RefPtr<Caps> get_allowed_caps();
  
  Glib::RefPtr<const Caps> get_allowed_caps() const;
  
  Glib::RefPtr<Caps> get_negotiated_caps();
  
  Glib::RefPtr<const Caps> get_negotiated_caps() const;

  
  bool set_caps (const Glib::RefPtr<Caps>& caps);
  
  Glib::RefPtr<Pad> get_peer();
  
  Glib::RefPtr<const Pad> get_peer() const;
  
  Glib::RefPtr<Caps> peer_get_caps();
  
  Glib::RefPtr<const Caps> peer_get_caps() const;
  
  void use_fixed_caps();
  
  bool is_active() const;
  
  bool set_blocked(bool blocked = true);
  
  bool is_blocked() const;
  
  bool is_blocking() const;

  
  void remove_data_probe(guint handler_id);
  
  void remove_buffer_probe(guint handler_id);
  
  void remove_event_probe(guint handler_id);

  
  bool accept_caps(const Glib::RefPtr<Caps>& caps);

  
  bool proxy_setcaps(const Glib::RefPtr<Caps>& caps);

  
  void fixate_caps(const Glib::RefPtr<Caps>& caps);

  
  bool peer_accept_caps(const Glib::RefPtr<Caps>& caps);

  
  bool check_pull_range() const;

  
  bool activate_pull(bool active = true);
  
  bool activate_push(bool active = true);

  bool query_position(Format& format) const;
  
  bool query_position(Format& format, gint64& position) const;
  bool query_duration(Format& format) const;
  
  bool query_duration(Format& format, gint64& duration) const;
  bool query_convert(Format src_format, gint64 src_value, Format& dst_format, gint64& dst_value) const;
  bool query_peer_position(Format& format) const;
  
  bool query_peer_position(Format& format, gint64& position) const;
  bool query_peer_duration(Format& format) const;
   
  bool query_peer_duration(Format& format, gint64& duration) const;
   
  bool query_peer_convert(Format src_format, gint64 src_value, Format& dst_format, gint64& dst_value) const;

  
  bool pause_task() ;
  
  bool stop_task() ;
  
  bool set_active(bool active = true);

  
  typedef sigc::slot<void, bool> SlotPadBlockCallback;

  bool set_blocked_async(bool blocked, const SlotPadBlockCallback& slot);

  //_WRAP_SIGNAL(void have_data(const Glib::RefPtr<MiniObject>& mini_obj), "have-data")

 
  /**
   * @par Prototype:
   * <tt>void on_my_%linked(const Glib::RefPtr<Pad>& peer_pad)</tt>
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<Pad>& > signal_linked();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%request_link()</tt>
   */

  Glib::SignalProxy0< void > signal_request_link();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%unlinked(const Glib::RefPtr<Pad>& peer_pad)</tt>
   */

  Glib::SignalProxy1< void,const Glib::RefPtr<Pad>& > signal_unlinked();


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The capabilities of the pad.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Caps> > property_caps() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The direction of the pad.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<PadDirection> property_direction() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The GstPadTemplate of this pad.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<PadTemplate> property_template() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The GstPadTemplate of this pad.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<PadTemplate> property_template() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_linked(const Glib::RefPtr<Pad>& peer_pad);
  virtual void on_request_link();
  virtual void on_unlinked(const Glib::RefPtr<Pad>& peer_pad);
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::Pad
   */
  Glib::RefPtr<Gst::Pad> wrap(GstPad* object, bool take_copy = false);
}


#endif /* _GSTMM_PAD_H */

